unit frmInIOCPMessageServer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, fmIOCPSvrInfo, iocp_base, iocp_clients, iocp_server,
  iocp_sockets, iocp_managers, iocp_msgPacks, ExtCtrls, Buttons;

type
  TFormInIOCPMessageServer = class(TForm)
    Memo1: TMemo;
    InIOCPServer1: TInIOCPServer;
    InConnection1: TInConnection;
    btnStart: TButton;
    btnStop: TButton;
    btnConnect: TButton;
    btnDisconnect: TButton;
    btnSend: TButton;
    InMessageManager1: TInMessageManager;
    InMessageClient1: TInMessageClient;
    EditTarget: TEdit;
    btnBroad: TButton;
    InClientManager1: TInClientManager;
    InCertifyClient1: TInCertifyClient;
    btnLogin: TButton;
    btnLogout: TButton;
    EditUserName: TEdit;
    edtPort: TEdit;
    lbl1: TLabel;
    FrameIOCPSvrInfo1: TFrameIOCPSvrInfo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    BitBtn1: TBitBtn;
    InFileManager1: TInFileManager;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    InCustomManager1: TInCustomManager;
    InCustomClient1: TInCustomClient;
    Button1: TButton;
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure btnDisconnectClick(Sender: TObject);
    procedure InConnection1Error(Sender: TObject; const Msg: string);
    procedure btnSendClick(Sender: TObject);
    procedure btnBroadClick(Sender: TObject);
    procedure btnLoginClick(Sender: TObject);
    procedure InClientManager1Login(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure FormCreate(Sender: TObject);
    procedure InMessageClient1ReturnResult(Sender: TObject;
      Result: TResultParams);
    procedure btnLogoutClick(Sender: TObject);
    procedure InCertifyClient1Certify(Sender: TObject; Action: TActionType;
      ActResult: Boolean);
    procedure InMessageManager1Receive(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure EditUserNameDblClick(Sender: TObject);
    procedure InMessageClient1MsgReceive(Sender: TObject; Socket: UInt64;
      Msg: string);
    procedure InIOCPServer1AfterOpen(Sender: TObject);
    procedure InMessageManager1Broadcast(Sender: TObject;
      Params: TReceiveParams; Result: TReturnResult);
    procedure InMessageManager1Get(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure InMessageManager1Push(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure InConnection1ReceiveMsg(Sender: TObject; Msg: TResultParams);
    procedure InCertifyClient1ReturnResult(Sender: TObject;
      Result: TResultParams);
    procedure BitBtn1Click(Sender: TObject);
    procedure InMessageClient1ListFiles(Sender: TObject;
      ActResult: TActionResult; No: Integer; Result: TCustomPack);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure InIOCPServer1AfterClose(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure InCustomManager1Receive(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure InIOCPServer1Connect(Sender: TObject; Socket: TBaseSocket);
    procedure InIOCPServer1Disconnect(Sender: TObject; Socket: TBaseSocket);
    procedure InMessageManager1ListFiles(Sender: TObject;
      Params: TReceiveParams; Result: TReturnResult);
  private
    { Private declarations }
    FAppDir: String;
    FLastMsgId: UInt64;  // ؼ¼Ϣ
  public
    { Public declarations }
  end;

var
  FormInIOCPMessageServer: TFormInIOCPMessageServer;
  InstanceCount: Integer;

implementation

uses
  iocp_log, iocp_varis, iocp_utils;

{$R *.dfm}

procedure TFormInIOCPMessageServer.BitBtn1Click(Sender: TObject);
begin
  // ȡϢ InMessageClient1.OnReturnResult 
  InMessageClient1.GetOfflineMsgs;
end;

procedure TFormInIOCPMessageServer.BitBtn2Click(Sender: TObject);
begin
  // гûڷ˵Ϣļ
  //  InMessageClient1.OnListFiles 
  InMessageClient1.GetMsgFiles;
end;

procedure TFormInIOCPMessageServer.BitBtn3Click(Sender: TObject);
var
  Msg: TMessagePack;
begin
  // ֱӷϢ
  Msg := TMessagePack.Create(InMessageClient1); // Ϊ InMessageClient1
  Msg.Msg := 'Ϣ.';
  Msg.Post(atTextSend);                              

  // Ϣ
  Msg := TMessagePack.Create(InMessageClient1); // Ϊ InMessageClient1
  Msg.Msg := 'Ϣ+.';
  Msg.LoadFromFile('doc\jediapilib.inc'); // ˳Ӹ
  Msg.Post(atTextSend);

end;

procedure TFormInIOCPMessageServer.btnBroadClick(Sender: TObject);
begin
  // ԱȨ޲ܹ㲥
  InMessageClient1.Broadcast('㲥Ϣ... ...');
end;

procedure TFormInIOCPMessageServer.btnConnectClick(Sender: TObject);
begin
  InConnection1.Active := True;
end;

procedure TFormInIOCPMessageServer.btnDisconnectClick(Sender: TObject);
begin
  InConnection1.Active := False;
end;

procedure TFormInIOCPMessageServer.btnLoginClick(Sender: TObject);
begin
  InCertifyClient1.UserName := EditUserName.Text;
  InCertifyClient1.Password := 'AAABBB';
  InCertifyClient1.Login;
end;

procedure TFormInIOCPMessageServer.btnLogoutClick(Sender: TObject);
begin
  InCertifyClient1.Logout;
end;

procedure TFormInIOCPMessageServer.btnSendClick(Sender: TObject);
begin
  // б໥֮Ϣ
  // ϢķΪ InConnection.UserNameڲԶ
  //  InConnection.OnReceiveMsg дյϢϢ
  if EditTarget.Text <> '' then
    InMessageClient1.SendMsg('Ƿ ' + EditTarget.Text + ' Ϣ.', EditTarget.Text)
  else
    InMessageClient1.SendMsg('Ϣˣ壩');
end;

procedure TFormInIOCPMessageServer.btnStartClick(Sender: TObject);
begin
  Memo1.Lines.Clear;
  
  iocp_log.TLogThread.InitLog;   // ־

  InIOCPServer1.ServerPort := StrToInt(edtPort.Text);
  InIOCPServer1.Active := True;  // 

  FrameIOCPSvrInfo1.Start(InIOCPServer1);  // ʼͳ

end;

procedure TFormInIOCPMessageServer.btnStopClick(Sender: TObject);
begin
  InIOCPServer1.Active := False; // ֹͣ
  FrameIOCPSvrInfo1.Stop;        // ֹͣͳ
  iocp_log.TLogThread.StopLog;   // ֹͣ־
end;

procedure TFormInIOCPMessageServer.Button1Click(Sender: TObject);
begin
  // ԶϢ EditTarget
  //   : InCustomManager1ReceiveInConnection1ReceiveMsg
  with InCustomClient1 do
  begin
    Params.ToUser := EditTarget.Text; // Ŀ
    Params.AsString['xxxx'] := 'ԶϢ, aaaa 1234667890, bbb';
    Post;
  end;
end;

procedure TFormInIOCPMessageServer.EditUserNameDblClick(Sender: TObject);
begin
  EditUserName.Text := 'USER_b';
end;

procedure TFormInIOCPMessageServer.FormCreate(Sender: TObject);
begin
  if InstanceCount = 1 then
  begin
    EditUserName.Text := 'user_b';
    EditTarget.Text := 'user_a';
    btnStart.Enabled := False;
    btnStop.Enabled := False;
  end;

  FLastMsgId := 0;

  // ׼·
  FAppDir := ExtractFilePath(Application.ExeName);
  iocp_utils.IniDateTimeFormat;    // ʱʽ
    
  // ͻݴ·2.0ƣ
  iocp_Varis.gUserDataPath := FAppDir + 'client_data\';

  MyCreateDir(FAppDir + 'log');    // Ŀ¼
  MyCreateDir(FAppDir + 'temp');   // Ŀ¼

  // Եû·
  MyCreateDir(iocp_Varis.gUserDataPath);  // Ŀ¼

  MyCreateDir(iocp_Varis.gUserDataPath + 'user_a');
  MyCreateDir(iocp_Varis.gUserDataPath + 'user_a\data');
  MyCreateDir(iocp_Varis.gUserDataPath + 'user_a\msg');
  MyCreateDir(iocp_Varis.gUserDataPath + 'user_a\temp');

  MyCreateDir(iocp_Varis.gUserDataPath + 'user_b');
  MyCreateDir(iocp_Varis.gUserDataPath + 'user_b\data');
  MyCreateDir(iocp_Varis.gUserDataPath + 'user_b\msg');
  MyCreateDir(iocp_Varis.gUserDataPath + 'user_b\temp');

end;

procedure TFormInIOCPMessageServer.InCertifyClient1Certify(Sender: TObject;
  Action: TActionType; ActResult: Boolean);
begin
  case Action of
    atUserLogin: begin      // ¼
      if ActResult then
        Memo1.Lines.Add(TInCertifyClient(Sender).UserName + ': ¼ɹ')
      else
        Memo1.Lines.Add(TInCertifyClient(Sender).UserName + ': ¼ʧ');
    end;
    atUserLogout: begin     // ǳ
      if ActResult then
        Memo1.Lines.Add(TInCertifyClient(Sender).UserName + ': ǳɹ')
      else
        Memo1.Lines.Add(TInCertifyClient(Sender).UserName + ': ǳʧ');
    end;
  end;
end;

procedure TFormInIOCPMessageServer.InCertifyClient1ReturnResult(Sender: TObject;
  Result: TResultParams);
var
  i, k: Integer;
  Msg: TReceivePack;  // Ϣ
  Reader: TMessageReader;  // ϢĶ
begin
  // ¼ʱϢﴦ
  if Assigned(Result.Attachment) then // иϢ
  begin
    Memo1.Lines.Add('Ϣ.');
    Msg := TReceivePack.Create;
    Reader := TMessageReader.Create;
    try
      // Attachment Ѿرգδͷ
      // ļϢļ -> Count = 0
      Reader.Open(Result.Attachment.FileName);

      // ǰ MsgId 浽̣
      // ¼ǰ벢 LastMsgId = ???
      // Ϣļж LastMsgId Ϣ

      for i := 0 to Reader.Count - 1 do
      begin
        if Reader.Extract(Msg, FLastMsgId) then  //  LastMsgId Ϣ
          for k := 0 to Msg.Count - 1 do
            with Msg.Fields[k] do
              Memo1.Lines.Add(Name + '=' + AsString);
      end;

      // Ϣ
      if Msg.Action <> atUnknown then
        FLastMsgId := Msg.MsgId;

    finally
      Msg.Free;
      Reader.Free;
    end;
  end;
end;

procedure TFormInIOCPMessageServer.InClientManager1Login(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // ͻ˵¼ʺ룡
  //   Խ TInDatabaseManager

  // Ԥ user_auser_b ûĿ¼
  // ûʱҪӦĿ¼

  if Params.Password <> '' then // 
  begin
    Result.Msg := '¼ɹ';   // һϢ
    Result.Role := crAdmin;     // Թ㲥ҪõȨޣ2.0ģ
    Result.ActResult := arOK;
    
    // Ǽ, Զû·עʱ
    InClientManager1.Add(Params.Socket, crAdmin);

    // Ϣ루ܺļϢ
    // Ҳڿͻ˷ arTextGet ȡϢ
    InMessageManager1.ReadMsgFile(Params, Result);
  end else
  begin
    Result.Msg := '¼ʧ';
    Result.ActResult := arFail;  // arErrUser ǷǷûᱻϿ
  end;
end;

procedure TFormInIOCPMessageServer.InConnection1Error(Sender: TObject;
  const Msg: string);
begin
  // طͻ˵ĸ쳣
  // TInConnection.DoServerErrorTInConnection.DoThreadFatalError
  Memo1.Lines.Add(Msg);
end;

procedure TFormInIOCPMessageServer.InConnection1ReceiveMsg(Sender: TObject;
  Msg: TResultParams);
begin
  // ﴦյϢϢ
  case Msg.Action of
    atTextPush, atTextBroadcast:
      Memo1.Lines.Add('յϢ' + Msg.Msg + ', ԣ' + Msg.UserName);
    atCustomAction:  // ԶϢ
      Memo1.Lines.Add(Msg.AsString['xxxx']);
  end;
end;

procedure TFormInIOCPMessageServer.InCustomManager1Receive(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
var
  oSocket: TIOCPSocket;
begin
  // յԶϢ
  if InClientManager1.Logined(Params.ToUser, oSocket) then
  begin
  //  InMessageManager1.PushMsg(Params, oSocket); // = Params.Socket.Push(oSocket);
    Result.ActResult := arOK; // Ͷųȥˣ֪
  end else
    Result.ActResult := arOffline;   // Է
end;

procedure TFormInIOCPMessageServer.InIOCPServer1AfterClose(Sender: TObject);
begin
  btnStart.Enabled := not InIOCPServer1.Active;
  btnStop.Enabled := InIOCPServer1.Active;
end;

procedure TFormInIOCPMessageServer.InIOCPServer1AfterOpen(Sender: TObject);
begin
  btnStart.Enabled := not InIOCPServer1.Active;
  btnStop.Enabled := InIOCPServer1.Active;
  memo1.Lines.Add('IP:' + InIOCPServer1.ServerAddr);
  memo1.Lines.Add('Port:' + IntToStr(InIOCPServer1.ServerPort));
end;

procedure TFormInIOCPMessageServer.InIOCPServer1Connect(Sender: TObject;
  Socket: TBaseSocket);
begin
  // ʹ Data ԣչһ¹
  // ֱֹ Socket.Close;
{  Socket.Data := TInMemStream.Create;   }
end;

procedure TFormInIOCPMessageServer.InIOCPServer1Disconnect(Sender: TObject;
  Socket: TBaseSocket);
begin
  // Ҫжͷ Data 
  // ϵͳĬϵĿͻ˶ THttpSocket
  // Socket ԴתΪӦЭ TBaseSocket 󣬻ر Socket
  // ʱҪжһ£ Socket.Connected = False Դת Socketô
{  if Socket.Connected and Assigned(Socket.Data) then
    TInMemStream(Socket.Data).Free;   }
end;

procedure TFormInIOCPMessageServer.InMessageClient1ListFiles(Sender: TObject;
  ActResult: TActionResult; No: Integer; Result: TCustomPack);
begin
  // atFileList, atTextGetFiles ִб¼,ִ OnReturnResult
  case ActResult of
    arFail:
      Memo1.Lines.Add('Ŀ¼.');
    arEmpty:
      Memo1.Lines.Add('Ŀ¼Ϊ.');
    arExists:  // г˵ǰ·µļ
      Memo1.Lines.Add(IntToStr(No) + ': ' +
                      Result.AsString['name'] + ', ' +
                      IntToStr(Result.AsInt64['size']) + ', ' +
                      DateTimeToStr(Result.AsDateTime['CreationTime']) + ', ' +
                      DateTimeToStr(Result.AsDateTime['LastWriteTime']) + ', ' +
                      Result.AsString['dir']);
  end;
end;

procedure TFormInIOCPMessageServer.InMessageClient1MsgReceive(Sender: TObject;
  Socket: UInt64; Msg: string);
begin
  // յͻϢģ
  Memo1.Lines.Add(InConnection1.UserName + ' յ ' + IntToStr(Socket) + ' Ϣ' + Msg);
end;

procedure TFormInIOCPMessageServer.InMessageClient1ReturnResult(Sender: TObject;
  Result: TResultParams);
begin
  // ¼
  // atFileList ִ OnListFiles,ִб¼    
  case Result.ActResult of
    arOK:
      Memo1.Lines.Add('Ϣͳɹ.' + Result.Msg);
    arOffline:
      Memo1.Lines.Add('Է.');
  end;

  // Ϣ
  InCertifyClient1ReturnResult(Sender, Result);
end;

procedure TFormInIOCPMessageServer.InMessageManager1Broadcast(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // 㲥Ϣȫͻ
  //       Ϣдȫͻ˵ķ㲻Уﲻ
//  Memo1.Lines.Add(Params.Msg);
  // 㲥пͻˣδ¼յ
  InMessageManager1.Broadcast(Params);
end;

procedure TFormInIOCPMessageServer.InMessageManager1Get(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // ȡϢͻ˷ arTextGet 
  InMessageManager1.ReadMsgFile(Params, Result);  // δϢ
  Result.Msg := 'Ϣ';
  Result.ActResult := arOK;
end;

procedure TFormInIOCPMessageServer.InMessageManager1ListFiles(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // ϢСΪ 2mʱļļг,
  // InternalOpenMsgFile
  // ļȡϢͻ˻Ϣ OnListFiles ʾ
  InFileManager1.ListFiles(Params, Result, True);
end;

procedure TFormInIOCPMessageServer.InMessageManager1Push(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // Ϣͻ: ToUserTargetUser
  
  // õʱ JSON ʽϢ
  //  mmoServer.Lines.Add(Params.ToJSON);

  // 1͸ͻˣToUserֻһͻƣ

  // 1.1 ȱ浽Ϣļ
  // InMessageManager1.SaveMsgFile(Params);

  // 1.2 ͻǷ
{  Result.UserName := Params.UserName;

  if InClientManager1.Logined(Params.ToUser, oSocket) then
  begin
    InMessageManager1.PushMsg(Params);
    Result.ActResult := arOK;
    Result.Msg := 'Ϣ: ' + Params.ToUser;
  end else
  begin
    Result.ActResult := arOffline;  // Է
    Result.Msg := 'û: ' + Params.ToUser;
  end;     }

  // 2ؿͻ˵״ֱ̬

  // 2.1 ͸ ToUserͻ","";"ָ
  InMessageManager1.PushMsg(Params, Params.ToUser);

  // 2.2 Ͷ
  if (Result.ActResult = arOK) then
    Result.Msg := 'ͶϢɹ.'
  else
    Result.Msg := 'ͶϢʧ.';
end;

procedure TFormInIOCPMessageServer.InMessageManager1Receive(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // ʱʾ
  Memo1.Lines.Add('յϢ' + Params.Msg); //

  // һļظͻˣͻ˴·:
  //   InConnection1.LocalPath
  Result.LoadFromFile('doc\jediapilib.inc');

  Result.ActResult := arOK;

  // Ϣûոķַո

  // 1. Ƽļ
  if (Params.AttachSize > 0) then
    InFileManager1.CreateNewFile(Params); // 浽û·
//  InFileManager1.CreateNewFile(Params, True); // 浽ûʱ·

  // 2. Ҳֱָ·
{  if (Params.AttachSize > 0) then
    Params.CreateAttachment(iocp_varis.gUserDataPath +
                          Params.UserName + '\temp\');    }

end;

end.
