unit frmInIOCPDBServer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, fmIOCPSvrInfo, iocp_base, iocp_clients, iocp_server,
  iocp_sockets, iocp_managers, iocp_msgPacks;

type
  TFormInIOCPDBServer = class(TForm)
    Memo1: TMemo;
    InIOCPServer1: TInIOCPServer;
    btnStart: TButton;
    btnStop: TButton;
    InClientManager1: TInClientManager;
    InDatabaseManager1: TInDatabaseManager;
    FrameIOCPSvrInfo1: TFrameIOCPSvrInfo;
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure InClientManager1Login(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure FormCreate(Sender: TObject);
    procedure InIOCPServer1AfterOpen(Sender: TObject);
    procedure InIOCPServer1AfterClose(Sender: TObject);
  private
    { Private declarations }
    FAppDir: String;
  public
    { Public declarations }
  end;

var
  FormInIOCPDBServer: TFormInIOCPDBServer;

implementation

uses
  iocp_log, iocp_varis, iocp_utils, dm_iniocp_test;

{$R *.dfm}

procedure TFormInIOCPDBServer.btnStartClick(Sender: TObject);
begin
  Memo1.Lines.Clear;
  
  iocp_log.TLogThread.InitLog;  // ־

  // עģࣨԶ֡ݿӣ
  InDatabaseManager1.AddDataModule(TdmInIOCPTest, 'Access-');
//  InDatabaseManager1.AddDataModule(TdmFirebird, 'Firebird-豸');
//  InDatabaseManager1.AddDataModule(TdmFirebird2, 'Firebird-Դ');

  InIOCPServer1.Active := True; // 
  FrameIOCPSvrInfo1.Start(InIOCPServer1);  // ʼͳ
end;

procedure TFormInIOCPDBServer.btnStopClick(Sender: TObject);
begin
  InIOCPServer1.Active := False;   // ֹͣ
  FrameIOCPSvrInfo1.Stop;          // ֹͣͳ
  iocp_log.TLogThread.StopLog;   // ֹͣ־
end;

procedure TFormInIOCPDBServer.FormCreate(Sender: TObject);
begin
  // ׼·
  FAppDir := ExtractFilePath(Application.ExeName);
  iocp_utils.IniDateTimeFormat;    // ʱʽ

  // ͻݴ·2.0ƣ
  iocp_Varis.gUserDataPath := FAppDir + 'client_data\';

  MyCreateDir(FAppDir + 'log');    // Ŀ¼
  MyCreateDir(FAppDir + 'temp');   // Ŀ¼
  MyCreateDir(iocp_Varis.gUserDataPath);  // Ŀ¼
end;

procedure TFormInIOCPDBServer.InClientManager1Login(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  if (Params.Password <> '') then
  begin
    Result.Role := crAdmin;   //  crAdmin Ȩޣܹ㲥
    Result.ActResult := arOK;
    // Ǽԡûƹ·
    InClientManager1.Add(Params.Socket, crAdmin);
  end else
    Result.ActResult := arFail;
end;

procedure TFormInIOCPDBServer.InIOCPServer1AfterClose(Sender: TObject);
begin
  btnStart.Enabled := not InIOCPServer1.Active;
  btnStop.Enabled := InIOCPServer1.Active;
end;

procedure TFormInIOCPDBServer.InIOCPServer1AfterOpen(Sender: TObject);
begin
  btnStart.Enabled := not InIOCPServer1.Active;
  btnStop.Enabled := InIOCPServer1.Active;
  Memo1.Lines.Add('server ip: ' + InIOCPServer1.ServerAddr);
  Memo1.Lines.Add('port: ' + IntToStr(InIOCPServer1.ServerPort));
end;

end.
