unit frmInIOCPMsgServer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls, ExtCtrls, fmIOCPSvrInfo,
  iocp_server, http_objects, iocp_msgPacks, iocp_managers, iocp_sockets;

type
  TFormInIOCPMsgServer = class(TForm)
    InIOCPServer1: TInIOCPServer;
    InFileManager1: TInFileManager;
    InClientManager1: TInClientManager;
    InMessageManager1: TInMessageManager;
    InDatabaseManager1: TInDatabaseManager;
    InHttpDataProvider1: TInHttpDataProvider;
    btnStart: TButton;
    btnStop: TButton;
    FrameIOCPSvrInfo1: TFrameIOCPSvrInfo;
    Memo1: TMemo;
    lbEditIP: TLabeledEdit;
    lbEditPort: TLabeledEdit;
    Button1: TButton;
    procedure btnStartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure InIOCPServer1AfterOpen(Sender: TObject);
    procedure InHttpDataProvider1Get(Sender: TObject; Request: THttpRequest;
      Respone: THttpRespone);
    procedure InClientManager1Delete(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure InClientManager1Login(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure InClientManager1QueryState(Sender: TObject;
      Params: TReceiveParams; Result: TReturnResult);
    procedure InIOCPServer1Disconnect(Sender: TObject; Socket: TBaseSocket);
    procedure InClientManager1Modify(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure InClientManager1Register(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure InClientManager1Logout(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure InMessageManager1Get(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure InMessageManager1Broadcast(Sender: TObject;
      Params: TReceiveParams; Result: TReturnResult);
    procedure InMessageManager1ListFiles(Sender: TObject;
      Params: TReceiveParams; Result: TReturnResult);
    procedure InMessageManager1Push(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure InMessageManager1Receive(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure InFileManager1AfterDownload(Sender: TObject;
      Params: TReceiveParams; Document: TIOCPDocument);
    procedure InFileManager1AfterUpload(Sender: TObject; Params: TReceiveParams;
      Document: TIOCPDocument);
    procedure InFileManager1BeforeUpload(Sender: TObject;
      Params: TReceiveParams; Result: TReturnResult);
    procedure InFileManager1BeforeDownload(Sender: TObject;
      Params: TReceiveParams; Result: TReturnResult);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormInIOCPMsgServer: TFormInIOCPMsgServer;

implementation

uses
  iocp_varis, iocp_log, iocp_base, iocp_utils,
  dm_iniocp_sqlite3;

{$R *.dfm}

procedure TFormInIOCPMsgServer.btnStartClick(Sender: TObject);
begin
  if InIOCPServer1.Active then
  begin
    InIOCPServer1.Active := False;  // ԶעģϢ
    FrameIOCPSvrInfo1.Stop;  // ͳģ
    iocp_log.TLogThread.StopLog;
  end else
  begin
    iocp_log.TLogThread.InitLog('log');  // ־д־iocp_log.WriteLog()
    InDatabaseManager1.AddDataModule(TdmInIOCPSQLite3, 'ͻ');  // עģ

    InIOCPServer1.ServerAddr := lbEditIP.Text;
    InIOCPServer1.ServerPort := StrToInt(lbEditPort.Text);

    InIOCPServer1.Active := True;  // 
    FrameIOCPSvrInfo1.Start(InIOCPServer1);  // ͳģ
  end;
end;

procedure TFormInIOCPMsgServer.FormCreate(Sender: TObject);
begin
  gUserDataPath := gAppPath + 'data\data_server\';
  MyCreateDir(gAppPath + 'log');  // ־Ŀ¼
  MyCreateDir(gAppPath + 'SQL');  // SQL Ŀ¼
  MyCreateDir(gUserDataPath);     // ûĿ¼
end;

procedure TFormInIOCPMsgServer.InClientManager1Delete(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // Sender  TBusiWorker DataModule ʱע TdmInIOCPSQLite3 ʵ
  // ɾû

  Result.UserName := Params.UserName;
  if (Params.ToUser <> Params.LogName) then  // LogName ǵ¼ʱƣParams.LogName = Params.Socket.LogName
  begin
    // ѯɾû ToUser Ȩ
    TdmInIOCPSQLite3(TBusiWorker(Sender).DataModule).QueryUser(Params, Result);

    if (Result.ActResult <> arOK) then
    begin
      Result.Msg := 'û ' + Params.ToUser + ' .';
    end else
    if (TIOCPSocket(Params.Socket).Role > Result.Role) then // Ȩ
    begin
      TdmInIOCPSQLite3(TBusiWorker(Sender).DataModule).DeleteUser(Params, Result);

      if (Result.ActResult = arOK) then  // ݱɾɹ
      begin
        InClientManager1.Disconnect(Params.ToUser);  // Ͽͻ
        Result.Msg := 'ɾûɹ: ' + Params.ToUser;
      end;
    end else
    begin
      Result.ActResult := arFail;
      Result.Msg := 'ɾû, Ȩ޲.';
    end;
  end else
  begin
    Result.ActResult := arFail;
    Result.Msg := 'ɾԼ.';
  end;

  // ͸ԼȫԱ
  InMessageManager1.PushToAdmin(Result);
  
end;

procedure TFormInIOCPMsgServer.InClientManager1Login(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // Sender  TBusiWorker DataModule ʱע TdmInIOCPSQLite3 ʵ
  // ¼
  
  // ȡûϢͻ˺ļݿ.SQL" [USER_LOGIN]
  TdmInIOCPSQLite3(TBusiWorker(Sender).DataModule).UserLogin(Params, Result);

  if (Result.ActResult = arOK) then  // û
  begin
    Result.Msg := 'Login OK';
    Result.UserName := Params.UserName;
    Result.AsDateTime['action_time'] := Now;

    // ǼϢǰ Role
    // ¼û·עʱϢ Socket.Evir
    //   Params.UserName ᱻ浽 Socket.LogName 
    InClientManager1.Add(Params.Socket, Result.Role);  // ûͳһΪСд

    // ͸ԼȫԱ
    InMessageManager1.PushToAdmin(Result);

    // ԱȨʱֱӹ㲥
//    InMessageManager1.Broadcast(Result);  // Ȩ
  end else
  begin
    Result.Msg := 'Login Fail';
    // Result.ActResult  arErrUser Ͽ
  end;
end;

procedure TFormInIOCPMsgServer.InClientManager1Logout(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // Sender  TBusiWorker DataModule ʱע TdmInIOCPSQLite3 ʵ
  // ǳ
  
  if (Params.UserName = Params.LogName) then  // LogName ǵ¼ʱ
  begin
    // µǳʱ䣬ͻ˺ļݿ.SQL" [USER_LOGOUT]
    TdmInIOCPSQLite3(TBusiWorker(Sender).DataModule).UserLogout(Params, Result);

    if (Result.ActResult = arOK) then
    begin
      // ͻϢ
      Result.Msg := 'User Logout.';
      Result.UserName := Params.UserName;
      Result.AsDateTime['action_time'] := Now;

      // ͸ԼȫԱ
      InMessageManager1.PushToAdmin(Result);

      // ԱȨʱֱӹ㲥
//      InMessageManager1.Broadcast(Result);  // Ȩ
    end;
  end else
  begin
    // ǿͻ˲ֵô
    Result.ActResult := arFail;
    Result.Msg := 'ͻ¼Ʋͬ.';
  end;

end;

procedure TFormInIOCPMsgServer.InClientManager1Modify(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // ޸ģδȨޣ
  
  // ͻ˺ļݿ.SQL" [USER_MODIFY]
  TdmInIOCPSQLite3(TBusiWorker(Sender).DataModule).ModifyUser(Params, Result);

  Result.UserName := Params.UserName;
  if Result.ActResult = arOK  then
    Result.Msg := '޸ûϢɹ: ' + Params.ToUser;

  // ͸ԼȫԱ
  InMessageManager1.PushToAdmin(Result);
  
end;

procedure TFormInIOCPMsgServer.InClientManager1QueryState(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // ѯ Params.ToUser ״̬ѯ̸ı䣩

  // ȼ Params.ToUser ǷڣټǷ¼
  TdmInIOCPSQLite3(TBusiWorker(Sender).DataModule).QueryUser(Params, Result);
  if (Result.ActResult = arOK) then
    InClientManager1.GetClientState(Params.ToUser, Result);
end;

procedure TFormInIOCPMsgServer.InClientManager1Register(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // עû Params.ToUser ݿ⣨δӵ¼

  // ûĿ¼Ϊ iocp_varis.gUserDataPathҪ½
  // û Params.ToUser ļĿ¼ٽĿ¼
  //   1. ToUser\Data: Ҫļ
  //   2. ToUser\Msg:  Ϣļ
  //   3. ToUser\Temp: Żʱļ
  //  ļ

  if (TIOCPSocket(Params.Socket).Role >= crAdmin) then // Ȩ
  begin
    // ͻ˺ļݿ.SQL" [USER_REGISTER]
    TdmInIOCPSQLite3(TBusiWorker(Sender).DataModule).RegisterUser(Params, Result);

    Result.UserName := Params.UserName;

    if (Result.ActResult = arOK) then
    begin
      MyCreateDir(iocp_varis.gUserDataPath + Params.ToUser + '\data');
      MyCreateDir(iocp_varis.gUserDataPath + Params.ToUser + '\msg');
      MyCreateDir(iocp_varis.gUserDataPath + Params.ToUser + '\temp');
      Result.Msg := 'עûɹ: ' + Params.ToUser;
    end;
  end else
  begin
    Result.ActResult := arFail;
    Result.Msg := 'עû, ' + Params.UserName + 'Ȩ޲.';
  end;

  // ͸ԼȫԱ
  InMessageManager1.PushToAdmin(Result);
  
end;

procedure TFormInIOCPMsgServer.InFileManager1AfterDownload(Sender: TObject;
  Params: TReceiveParams; Document: TIOCPDocument);
begin
  // ļϴ¼
end;

procedure TFormInIOCPMsgServer.InFileManager1AfterUpload(Sender: TObject;
  Params: TReceiveParams; Document: TIOCPDocument);
begin
  // ļϴϴ¼Ҫעļ·ȫ
  // °ͷToUser бֱӵü.
  if (Params.Action = atFileUpShare) and (Params.ToUser <> '') then
    InMessageManager1.PushMsg(Params, Params.ToUser);  // ѻ򱣴浽ļ
end;

procedure TFormInIOCPMsgServer.InFileManager1BeforeDownload(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // ļԱ
  if Params.Action = atFileDownShare then  // عļ
    InFileManager1.OpenLocalFile(Result, 'data\public_temp\' + Params.FileName)
  else
    InFileManager1.OpenLocalFile(Result, 'bin\' + Params.FileName);  // ϸ˵Ӧ򿪹·ļ
  Result.Msg := 'ļ';
end;

procedure TFormInIOCPMsgServer.InFileManager1BeforeUpload(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // ҪϴļȽļ
  // Ҳʹַգ
  // Params.CreateAttachment('·');

  // Ϣʱļ·漰ȫ
  //    atFileShare ʱһõʱ·ļ

  if Params.Action = atFileUpShare then
    Params.CreateAttachment('data\public_temp\')
  else
    InFileManager1.CreateNewFile(Params);

  Result.Msg := 'ϴļ' + Params.Attachment.FileName;
// ĬϷؽResult.ActResult := arAccept; 
  
  Memo1.Lines.Add('ϴļ' + Params.Attachment.FileName);
    
end;

procedure TFormInIOCPMsgServer.InHttpDataProvider1Get(Sender: TObject;
  Request: THttpRequest; Respone: THttpRespone);
begin
  // HTTP 񣬷Ϣ
  Respone.SetContent('InIOCP HTTP Server v2.5 IS RUNING!');
end;

procedure TFormInIOCPMsgServer.InIOCPServer1AfterOpen(Sender: TObject);
begin
  btnStart.Enabled := not InIOCPServer1.Active;
  btnStop.Enabled := not btnStart.Enabled;
end;

procedure TFormInIOCPMsgServer.InIOCPServer1Disconnect(Sender: TObject; Socket: TBaseSocket);
var
  Result: TReturnResult;
begin
  // Socket رգδ¼ԵǳµĹر
  if (Socket is TIOCPSocket) then
  begin
    Result := TIOCPSocket(Socket).Result;
    if Assigned(Result) and (Result.Action <> atUserLogout) then  // ǵǳĹر
    begin
      Result.Msg := 'Ͽ';
      InMessageManager1.Broadcast(Result);  // ƽ㲥
    end;
  end;
end;

procedure TFormInIOCPMsgServer.InMessageManager1Broadcast(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // 㲥ϢȫͻˣԼȨ
  Result.UserName := Params.UserName;
  Result.Msg := '㲥Ϣѷ.';
  Result.ActResult := arOK;

  // 3 ֹ㲥
  InMessageManager1.Broadcast(Params);
//  InMessageManager1.Broadcast(Result);
//  InMessageManager1.Broadcast(Params.Socket, '㲥˵ı');

end;

procedure TFormInIOCPMsgServer.InMessageManager1Get(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // Ϣظͻ
  InMessageManager1.ReadMsgFile(Params, Result);
end;

procedure TFormInIOCPMsgServer.InMessageManager1ListFiles(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // гϢļ
  InFileManager1.ListFiles(Params, Result, True);
end;

procedure TFormInIOCPMsgServer.InMessageManager1Push(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
//var
//  oSocket: TIOCPSocket;
begin
  // Ϣͻ: ToUserTargetUser

  // 1͸ͻˣToUserֻһͻƣ

  // 1.1 ȱ浽Ϣļ
  // InMessageManager1.SaveMsgFile(Params);

  // 1.2 ͻǷ
{  Result.UserName := Params.UserName;

  if InClientManager1.Logined(Params.ToUser, oSocket) then
  begin
    InMessageManager1.PushMsg(Params);
    Result.ActResult := arOK;
    Result.Msg := 'Ϣ: ' + Params.ToUser;
  end else
  begin
    Result.ActResult := arOffline;  // Է
    Result.Msg := 'û: ' + Params.ToUser;
  end;    }

  // 2ؿͻ˵״ֱ̬

  // 2.1 ͸ ToUserͻ","";"ָ
  InMessageManager1.PushMsg(Params, Params.ToUser);  // ȱڶʱΪ㲥

  // 2.2 ڶͷ
//  InMessageManager1.PushMsg(Params.Socket, 'ͷ˵Ϣ', Params.ToUser);  // ȱʱΪ㲥

  // Ͷ
  if (Result.ActResult = arOK) then
    Result.Msg := 'ͶϢɹ.'
  else
    Result.Msg := 'ͶϢʧ.';

  // 2.3 ͷ
//  InMessageManager1.PushMsg(Result, Params.ToUser);  // ȱڶʱΪ㲥

end;

procedure TFormInIOCPMsgServer.InMessageManager1Receive(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // յͻ˷ͨϢ
  if (Params.Msg = 'DISCONNECT') then  // Ͽָͻ
  begin
    InClientManager1.Disconnect(Params.ToUser);
    Result.UserName := Params.UserName;
    Result.Msg := 'ͶϿ.';
    Result.ActResult := arOK;
  end;
end;

end.
